/*****************************************************************************
 * Description: Header for qtPlaylist.cpp                                    *
 * Copyright:   2007 by Alexander Motzkau                                    *
 * License:     GPL V2                                                       *
 *****************************************************************************/

#ifndef QTPLAYLIST_H
#define QTPLAYLIST_H

#include <qwidget.h>
#include <qvbox.h>
#include <qlistbox.h>
#include <qtimer.h>

class PlaylistEntry;
class QListBox;
class qtPlaylistItem;

class qtPlaylist : public QWidget
{
    Q_OBJECT

public:
    qtPlaylist( QWidget* parent = 0, const char * name = 0,  WFlags fl = 0 );
    virtual ~qtPlaylist();

public slots:
    void select(int pos, PlaylistEntry* entry);
    void updateEntry(int pos, PlaylistEntry* entry);
    void removeEntry(int pos, PlaylistEntry* entry);
    void moveEntry(int oldpos, PlaylistEntry* entry, int newpos);

signals:
    void itemClicked(int pos);
    void itemRemove(int pos);
    void itemMove(int oldpos, int newpos);
	
public slots:
    void mouseClicked(int button, QListBoxItem* item, const QPoint& pos);
    void mousePressed(int button, QListBoxItem* item, const QPoint& pos);
    
    void itemRemove();
    void itemMove();
    void showPopup();

private:
    QListBox* listbox;

    QPopupMenu* popupmenu;
    qtPlaylistItem* popupitem;
    qtPlaylistItem* moveitem;
    QTimer popuptimer;
};

class qtPlaylistItem : public QListBoxText
{
    public:
	qtPlaylistItem(QListBox* listbox, int pos, PlaylistEntry* entry);
	virtual QString text () const;
	
	void updateEntry(PlaylistEntry* entry);
	PlaylistEntry* getEntry();

    private:
	PlaylistEntry* song;
};

#endif
