/*****************************************************************************
 * Description: Header for threads.cpp                                       *
 * Copyright:   2007 by Alexander Motzkau                                    *
 * License:     GPL V2                                                       *
 *****************************************************************************/

#ifndef THREADS_H
#define THREADS_H
#ifndef QT_THREAD_SUPPORT

#include <pthread.h>

class QThread
{
    public:
	QThread();
	virtual ~QThread();
	
	virtual void run();
	void start();

    private:
	static void* entry(void *me);
	pthread_t thread;
};

class QMutex
{
    public:
	QMutex();
	
	void lock();
	void unlock();

    private:
	pthread_mutex_t mutex;
};

class QWaitCondition
{
    public:
	QWaitCondition();
	
	void wait(QMutex* m);
	void wakeAll();

    private:
	pthread_mutex_t mutex;
	pthread_cond_t cond;
};

#endif
#endif
